<script setup lang="ts">
  import { ClientApiError } from '@shopware-pwa/types';
  import { required, email } from '@vuelidate/validators';
  import { useVuelidate } from '@vuelidate/core';
  import { getErrorMessages } from '~/helpers/errors';

  const emits = defineEmits<{
    (e: 'back-to-login'): void;
  }>();

  defineProps<{
    controller: ReturnType<typeof useModal>;
  }>();

  const resetPasswordErrorMsg = ref<string>();
  const isLoading = ref<boolean>();
  const isSubmitted = ref<boolean>(false);

  const state = reactive({
    email: '',
  });

  const { resetPassword } = useCustomerPassword();
  const { getStorefrontUrl } = useInternationalization();
  const rules = {
    email: {
      required,
      email,
    },
  };

  const storefrontUrl = computed(() => getStorefrontUrl());

  const $v = useVuelidate(rules, state);

  const invokeSubmit = async (e: Event): Promise<void> => {
    e.preventDefault();
    $v.value.$touch();
    const valid = await $v.value.$validate();

    if (valid) {
      try {
        isLoading.value = true;

        await resetPassword({
          email: state.email,
          storefrontUrl: storefrontUrl.value,
        });
        isSubmitted.value = true;
      } catch (e) {
        resetPasswordErrorMsg.value = getErrorMessages(e as ClientApiError) as string;
      } finally {
        isLoading.value = false;
      }
    }
  };
</script>

<template>
  <SwModal :modal-title="$t('resetPassword')" :controller="controller">
    <template #body>
      <div class="flex">
        <div v-if="!isSubmitted" class="w-sm">
          <div class="flex flex-col space-y-6">
            <span>{{ $t('forgotPasswordForm.description') }}</span>
            <SwTextField
              id="email"
              v-model="state.email"
              :placeholder="$t('loginForm.emailPlaceholder')"
              name="email"
              type="email"
              size="large"
              :errors="$v.email.$errors"
              :label="$t('email')"
              @blur="$v.email.$touch"
            />
          </div>
        </div>
        <div v-else>
          <SwEmptyState
            :title="$t('forgotPasswordForm.header')"
            :sublime="$t('forgotPasswordForm.sublime')"
          >
            <div
              class="h-18 w-18 mx-auto flex justify-center rounded-full bg-emerald-50 text-emerald-500"
            >
              <span class="i-sw-solid:envelope m-auto p-0" />
            </div>
          </SwEmptyState>
        </div>
        <SwBanner v-if="resetPasswordErrorMsg" class="mt-3" variant="error" :show-close-btn="false">
          {{ $t(resetPasswordErrorMsg) }}
        </SwBanner>
      </div>
    </template>
    <template #footer>
      <SwButton v-if="isSubmitted" size="large" @click="emits('back-to-login')">
        {{ $t('forgotPasswordForm.action') }}
      </SwButton>
      <div v-else>
        <SwButton size="large" variant="action" @click="emits('back-to-login')">
          {{ $t('back') }}
        </SwButton>
        <SwButton
          class="ml-4"
          size="large"
          type="submit"
          :loading="isLoading"
          @click="invokeSubmit"
        >
          {{ $t('send') }}
        </SwButton>
      </div>
    </template>
  </SwModal>
</template>
